<?php

if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

class ImportStat_Plugin
{ 
    var $my_config;
    var $plugin_name = 'ImportStat';
    var $prefixeTable;
    var $calc_time_start;

	/* -------------------------------------------------------------------------------------------------------
		fonctions activation/dsactivation
	   ------------------------------------------------------------------------------------------------------- */
	function erase_temp_tables()
	{
		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_tmp";
		$result=pwg_query($sql);

		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_HistoryBackup";
		$result=pwg_query($sql);
	}

	function init($prefixeTable)
	{
		$this->prefixeTable = $prefixeTable;
	}

	function plugin_admin_menu($menu)
	{
	 array_push($menu,
	            array(
	                'NAME' => $this->plugin_name,
	                'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/plugin_admin.php')
	                 ));
	 return $menu;
	}

	function restore_backup()
	{
		$sql="SHOW TABLES LIKE '".$this->prefixeTable.$this->plugin_name."_HistoryBackup';";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)==1)
			{
				if($this->restore_history())
				{ $this->erase_temp_tables(); }
			}
		}
	}


	function calc_time($start, $prec = 5)
	{	
		if($start)
		{
			list($usec, $sec) = explode(" ", microtime());
			$this->calc_time_start = ((float)$usec + (float)$sec);
			return $this->calc_time_start;		
		}
		else
		{
			list($usec, $sec) = explode(" ", microtime());
			$calc_time_stop = ((float)$usec + (float)$sec);
			return round($calc_time_stop - $this->calc_time_start, $prec);
		}
	}
	
	/* -------------------------------------------------------------------------------------------------------
		fonctions grant l'import
	   ------------------------------------------------------------------------------------------------------- */
 	function do_query($sql)
	{
		$result=pwg_query($sql);
		if(!$result) 
		{ return(false); } 
		else 
		{ return(true); }
	}

	function do_step($step_to_do)
	{
		global $template;

		$next_step=$step_to_do+1;

		$nfo=$this->history_backup_nfo();
		if(is_array($nfo))
		{
			if($nfo['NbElem']>0)
			{
				$template->assign_var("IMPORTSTAT_NFO_HB", 
						sprintf(l10n('ImportStat_HB_Nfo'), $nfo['NbElem'], 
								date(l10n('ImportStat_date_format'), strtotime($nfo['MinDate'])), 
								date(l10n('ImportStat_date_format'), strtotime($nfo['MaxDate'])) ));
			}
			else
			{
				$template->assign_var("IMPORTSTAT_NFO_HB", l10n('ImportStat_HB_Nfo2'));
			}
		}



		$this->calc_time(true);
		switch($step_to_do)
		{
			case 0: $result=$this->step_0($nfo);
				break;
			case 1: $result=$this->step_1();
				break;
			case 2: $result=$this->step_2();
				break;
			case 3: $result=$this->step_3();
				break;
			case 4: $result=$this->step_4();
				break;
			case 5: $result=$this->step_5();
				break;
			case 6: $result=$this->step_6();
				break;
			case 7: $result=$this->step_7();
				break;
			case 8: $result=$this->step_8();
				break;
		}
		$time_to_do_sql=$this->calc_time(false);


		if($result)
		{
			$template->assign_var("IMPORTSTAT_PREVIOUS_STEP_RESULT_CLASS", "class='infos'");			
			if($step_to_do>0)
			{ 
				$template->assign_var("IMPORTSTAT_NEXT_STEP", $next_step);
				$template->assign_var("IMPORTSTAT_PROCEED", l10n('ImportStat_do_step')." $next_step");
				$template->assign_var("IMPORTSTAT_TIME", l10n('ImportStat_time_to_do_sql').$time_to_do_sql."s"); 
				$template->assign_var("IMPORTSTAT_PREVIOUS_STEP_RESULT", "[".l10n('ImportStat_step')." $step_to_do] ".l10n('ImportStat_step_result_ok_'.$step_to_do));			
				if($step_to_do>=8) { $template->assign_var("IMPORTSTAT_SHOWBUTTON", "style='display:none'"); }
			}
		}
		else
		{
			$template->assign_var("IMPORTSTAT_PREVIOUS_STEP_RESULT_CLASS", "class='errors'");			
			$template->assign_var("IMPORTSTAT_PREVIOUS_STEP_RESULT", "[".l10n('ImportStat_step')." $step_to_do] ".l10n('ImportStat_step_result_ko_'.$step_to_do));			
			$template->assign_var("IMPORTSTAT_SHOWBUTTON", "style='display:none'");
		}
	}

	function step_0($nfo)
	{	
		global $template;

		if(is_array($nfo))
		{
			if($nfo['NbElem']>0)
			{
				$previous_import=$this->look_for_previous_import($nfo['MaxDate']);
				if($previous_import>0)
				{
					$template->assign_block_vars(
					      'show_delete_previous',
						array(
						'TEXT' => sprintf(l10n('ImportStat_delete_previous'), 
								date(l10n('ImportStat_date_format'), strtotime($nfo['MaxDate'])))
			        	) );
					$template->assign_var("IMPORTSTAT_SHOWBUTTON", "style='display:none'");
					$template->assign_var("IMPORTSTAT_PREVIOUS_STEP_RESULT", l10n('ImportStat_step_result_ok_0B'));			
					$template->assign_var("IMPORTSTAT_NEXT_STEP", 0);
				}
				else
				{
					$template->assign_var("IMPORTSTAT_PREVIOUS_STEP_RESULT", l10n('ImportStat_step_result_ok_0'));			
					$template->assign_var("IMPORTSTAT_PROCEED", l10n('ImportStat_do_step')." 1");
					$template->assign_var("IMPORTSTAT_NEXT_STEP", "1");
				}
				return(true);
			}			
		}
		return(false);
	}

	function step_1()
	{
		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_tmp";
		$result=pwg_query($sql);

		$sql="CREATE TABLE ".$this->prefixeTable.$this->plugin_name."_tmp 
			(KEY iimages (image_id), KEY icategory (category_id), KEY icategory2 (category_name))
			SELECT 	DATE(date) AS date, 
				TIME (date) AS time, 
				YEAR(date) AS year, 
				MONTH(date) AS month, 
				DAY(date) AS day, 
				HOUR(date) AS hour,
				".$this->prefixeTable."users.id AS user_id, 
				IP, 
				'' AS section, 
				0 AS category_id, 
				NULL AS tag_ids,
				".$this->prefixeTable."history_backup.picture AS image_id, 
				'false' AS summarized,
				IF(".$this->prefixeTable."history_backup.picture = '', 'other', 'picture') AS image_type,
				TRIM(SUBSTRING_INDEX(".$this->prefixeTable."history_backup.category, '/', -1)) as category_name
			FROM 	".$this->prefixeTable."history_backup, 
				".$this->prefixeTable."users
			WHERE	".$this->prefixeTable."history_backup.login = ".$this->prefixeTable."users.username ; ";
		if($this->do_query($sql))
		{
			$enums=implode(',', $this->get_section_enum('old_deleted_cat'));
			$sql="ALTER TABLE ".$this->prefixeTable.$this->plugin_name."_tmp 
				 CHANGE `section` `section` 
				 ENUM (".$enums.") ;";
			return($this->do_query($sql));
		}
		else
		{return(false); }
	} 

	function step_2()
	{	
		$sql="UPDATE	".$this->prefixeTable.$this->plugin_name."_tmp, 
				".$this->prefixeTable."images  
			SET 	image_id = ".$this->prefixeTable."images.id
			WHERE 	".$this->prefixeTable."images.file = ".$this->prefixeTable.$this->plugin_name."_tmp.image_id;";
		if($this->do_query($sql))
		{
			$sql="UPDATE	".$this->prefixeTable.$this->plugin_name."_tmp 
				SET 	image_id = NULL WHERE ".$this->prefixeTable.$this->plugin_name."_tmp.image_id = '';";
			return($this->do_query($sql));
		}
		else
		{ return(false); }
	}

	function step_3()
	{	
		$sql="UPDATE	".$this->prefixeTable.$this->plugin_name."_tmp, 
					".$this->prefixeTable."categories 
				SET 	category_id = ".$this->prefixeTable."categories.id 
				WHERE 	".$this->prefixeTable.$this->plugin_name."_tmp.category_name = ".$this->prefixeTable."categories.name;";
		return($this->do_query($sql));
	}

	function step_4()
	{	
		/*$sql="UPDATE 	".$this->prefixeTable.$this->plugin_name."_tmp
			SET 	category_id = 0 
			WHERE 	".$this->prefixeTable.$this->plugin_name."_tmp.category_id NOT IN 
					(SELECT DISTINCT name FROM ".$this->prefixeTable."categories);";
		if($this->do_query($sql))
		{*/
			$sql="UPDATE	".$this->prefixeTable.$this->plugin_name."_tmp, 
					".$this->prefixeTable."images
				SET 	".$this->prefixeTable.$this->plugin_name."_tmp.category_id = ".$this->prefixeTable."images.storage_category_id
				WHERE	".$this->prefixeTable."images.storage_category_id != ".$this->prefixeTable.$this->plugin_name."_tmp.category_id
					AND ".$this->prefixeTable."images.id = ".$this->prefixeTable.$this->plugin_name."_tmp.image_id 
					AND ".$this->prefixeTable.$this->plugin_name."_tmp.image_id > 0";
			return($this->do_query($sql));
		/*}
		else
		{ return(false); }*/
	}

	function step_5()
	{
		$sql="UPDATE	".$this->prefixeTable.$this->plugin_name."_tmp, 
				".$this->prefixeTable."history_backup
			SET 	".$this->prefixeTable.$this->plugin_name."_tmp.section=
				IF(".$this->prefixeTable."history_backup.category='Recherche', 'search',
					IF(".$this->prefixeTable."history_backup.category='Accueil', 'list',
						IF(".$this->prefixeTable."history_backup.category='Images au hasard', 'list',
							IF(".$this->prefixeTable."history_backup.category='Dernires images', 'recent_pics',
								IF(".$this->prefixeTable."history_backup.category='Dernires catgories', 'recent_cats',
									IF(".$this->prefixeTable."history_backup.category='15 Plus vues', 'most_visited',
										IF(".$this->prefixeTable."history_backup.category='Favoris', 'favorites', 
											IF(".$this->prefixeTable."history_backup.category='Rsultats de recherche', 'search', 'old_deleted_cat'
											)
										)
									)
								)
							)
						)
					)
				)
			WHERE	CONCAT(".$this->prefixeTable.$this->plugin_name."_tmp.date, ' ', ".$this->prefixeTable.$this->plugin_name."_tmp.time) = ".$this->prefixeTable."history_backup.date
		and ".$this->prefixeTable.$this->plugin_name."_tmp.IP = ".$this->prefixeTable."history_backup.IP
		and ".$this->prefixeTable.$this->plugin_name."_tmp.category_id = 0 ;";
		if($this->do_query($sql))
		{
			$sql="UPDATE	".$this->prefixeTable.$this->plugin_name."_tmp 
				SET 	section = 'categories' 
				WHERE 	(category_id > 0) AND (section IS NULL or section = '');";
			return($this->do_query($sql));
		}
		else
		{ return(false); }
	}

	function step_6()
	{	
		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_HistoryBackup";
		if($this->do_query($sql))
		{
			$sql="CREATE TABLE ".$this->prefixeTable.$this->plugin_name."_HistoryBackup SELECT * FROM ".HISTORY_TABLE." ";
			return($this->do_query($sql));
		}
		else
		{ return(false); }
	}

	function step_7()
	{	
		$enums=implode(',', $this->get_section_enum('old_deleted_cat'));
		$sql="ALTER TABLE ".HISTORY_TABLE."
				 CHANGE `section` `section` 
				 ENUM (".$enums.") ;";
		if($this->do_query($sql));
		{
			$sql="INSERT INTO ".HISTORY_TABLE." 
					(date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, summarized, image_type) 				SELECT date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, summarized, image_type FROM ".$this->prefixeTable.$this->plugin_name."_tmp ORDER BY date, time;";
			return($this->do_query($sql));
		}
	}

	function step_8()
	{	
		$sql="DELETE FROM ".$this->prefixeTable."history_summary";
		return($this->do_query($sql));
	}

	
	function restore_history()
	{
		$enums=implode(',', $this->get_section_enum());

		$sql="DROP TABLE ".HISTORY_TABLE;
		$result=pwg_query($sql);
		if($result)
		{
			$sql="CREATE TABLE `".HISTORY_TABLE."` (
				  `id` int(10) unsigned NOT NULL auto_increment,
				  `date` date NOT NULL default '0000-00-00',
				  `time` time NOT NULL default '00:00:00',
				  `year` smallint(4) NOT NULL default '0',
				  `month` tinyint(2) NOT NULL default '0',
				  `day` tinyint(2) NOT NULL default '0',
				  `hour` tinyint(2) NOT NULL default '0',
				  `user_id` smallint(5) NOT NULL default '0',
				  `IP` varchar(15) NOT NULL default '',
				  `section` enum(".$enums.") default NULL,
				  `category_id` smallint(5) default NULL,
				  `tag_ids` varchar(50) default NULL,
				  `image_id` mediumint(8) default NULL,
				  `summarized` enum('true','false') default 'false',
				  `image_type` enum('picture','high','other') default NULL,
				  PRIMARY KEY  (`id`),
				  KEY `history_i1` (`summarized`)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
			$result=pwg_query($sql);
			if($result)
			{
				$sql="INSERT INTO ".HISTORY_TABLE." 
				(date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, summarized, image_type) 
				SELECT date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, summarized, image_type FROM ".$this->prefixeTable.$this->plugin_name."_HistoryBackup ORDER BY date, time;";
				return($this->do_query($sql));				
			}

		}
		return(false);
	}

	function get_section_enum($add)
	{
		$sql = 'SHOW COLUMNS FROM '.HISTORY_TABLE.' LIKE "section"';
		$result=pwg_query($sql);
		if($result)
		{
			$row = mysql_fetch_array($result);
			$list=substr($row['Type'], 5, strlen($row['Type'])-6);
			$returned=explode(',', $list);
			if(!in_array($add, $returned)&&($add!='')) { array_push($returned, "'$add'"); }
			return($returned);
	    	}

	}

	/* rcupre les infos de history_backup : nombre d'lments & date/heure du dernier lment */
	function history_backup_nfo()
	{
		$sql="SELECT COUNT(*) as NbElem, MIN(date) as MinDate, MAX(date) as MaxDate FROM ".$this->prefixeTable."history_backup";
		$result=pwg_query($sql);
		if($result)
		{
			$row=mysql_fetch_array($result);
			if(is_array($row))
			{
				return($row);
			}			
		}
		return(false);
	}

	/* vrifie si un import a dj t effectu */
	function look_for_previous_import($date)
	{
		$sql="SELECT COUNT(*) FROM ".HISTORY_TABLE." WHERE CONCAT(date, ' ', time)<= '$date'";
		$result=pwg_query($sql);
		if($result)
		{
			$row=mysql_fetch_row($result);
			return($row[0]);
		}
		return(0);
	}

	/* purge l'historique */
	function erase_old_import()
	{
		$nfo=$this->history_backup_nfo();
		if(is_array($nfo))
		{
			$sql="DELETE FROM ".HISTORY_TABLE." WHERE CONCAT(date, ' ', time)<= '".$nfo['MaxDate']."'";
			$result=pwg_query($sql);
			if($result)
			{
				return(true);
			}
		}
		return(false);
	}

}


?>
